



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Java集合类源码解析：ArrayList</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Java集合类源码解析：ArrayList</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-31 15:10:38 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><div>
<div>目录</div>
<ul><li><a href="#前言" rel="external nofollow noreferrer">前言</a></li>
<li><a href="#源码解析" rel="external nofollow noreferrer">源码解析</a>
<ul><li><a href="#基本成员变量" rel="external nofollow noreferrer">基本成员变量</a></li>
<li><a href="#添加元素" rel="external nofollow noreferrer">添加元素</a></li>
<li><a href="#查询元素" rel="external nofollow noreferrer">查询元素</a></li>
<li><a href="#修改元素" rel="external nofollow noreferrer">修改元素</a></li>
<li><a href="#删除元素" rel="external nofollow noreferrer">删除元素</a></li></ul></li>
<li><a href="#为什么用-transient-修饰数组变量" rel="external nofollow noreferrer">为什么用 "transient" 修饰数组变量</a></li>
<li><a href="#总结" rel="external nofollow noreferrer">总结</a></li></ul>
</div>
<h1>前言</h1>
<p>今天学习一个Java集合类使用最多的类 <strong>ArrayList</strong> , <strong>ArrayList</strong> 继承了 <a href="https://www.cnblogs.com/yeya/p/9950756.html" rel="external nofollow noreferrer">AbstractList</a>，并实现了<strong>List</strong> 和 <a href="https://www.cnblogs.com/yeya/p/9950723.html" rel="external nofollow noreferrer">RandomAccess</a> 等接口，</p>
<pre class="prettyprint linenums"><code>public class ArrayList&lt;E&gt; extends AbstractList&lt;E&gt;<br />
        implements List&lt;E&gt;, RandomAccess, Cloneable, java.io.Serializable<br />
</code></pre>
<p>是一个<strong>以数组形式</strong>存储数据的集合，它具有以下的特点：</p>
<p>集合中的数组是有序排列的；</p>
<p>允许元素为null；</p>
<p>允许重复的数据；</p>
<p>非线程安全；</p>
<p>针对它的这些特点，我们一步步跟进源码进行解析。</p>
<h1>源码解析</h1>
<h2>基本成员变量</h2>
<p>先看下ArrayList 的基本成员变量</p>
<pre class="prettyprint linenums"><code>transient Object[] elementData;<br />
private static final int DEFAULT_CAPACITY = 10;<br />
private int size;<br />
private static final int MAX_ARRAY_SIZE = Integer.MAX_VALUE - 8;<br />
</code></pre>
<p><code>elementData</code> ：一个object数组，组成了ArrayList 的底层数据结构，由于数组类型为 Object，所以允许添加 null 。值得注意的是，变量的修饰符是  <strong>transient</strong> ，这说明这个数组无法被序列化，但是之前ArrayList却实现了序列化接口，是可以被初始化，这不是互相矛盾了吗，关于这个原因，下面会说到，别急。</p>
<p><code>DEFAULT_CAPACITY</code> : 数组的初识容量</p>
<p><code>size</code> ： 数组元素个数</p>
<p><code>MAX_ARRAY_SIZE</code>： 数组最大容量</p>
<p>说完变量后，开始学习ArrayList 的基本方法，我们都知道，一个集合最重要的方法就是对元素的                增删改查操作，了解了这些操作的方法，也就基本了解了容器的运作机制。</p>
<h2>添加元素</h2>
<p>ArrayList 中最基础的添加元素方法是 <code>add(E e)</code></p>
<pre class="prettyprint linenums"><code>public boolean add(E e) {<br />
	//调整容量<br />
    ensureCapacityInternal(size + 1);  // Increments modCount!!<br />
    elementData[size++] = e;<br />
    return true;<br />
}<br />
</code></pre>
<p>源码逻辑比较简单，主要是先做了调整容量处理，并把元素存入数组的最后一个位置。</p>
<p>来看一下调整容量的方法 <strong>ensureCapacityInternal()</strong>，源码如下：</p>
<pre class="prettyprint linenums"><code>private void ensureCapacityInternal(int minCapacity) {<br />
	//如果是空数组，初始化容量，取默认容量和 当前元素个数 最大值<br />
    if (elementData == DEFAULTCAPACITY_EMPTY_ELEMENTDATA) {<br />
        minCapacity = Math.max(DEFAULT_CAPACITY, minCapacity);<br />
    }

    ensureExplicitCapacity(minCapacity);<br />
}

private void ensureExplicitCapacity(int minCapacity) {<br />
    modCount++;

    // overflow-conscious code<br />
    if (minCapacity - elementData.length &gt; 0)<br />
    	//容量不够，做扩容<br />
        grow(minCapacity);<br />
}

private void grow(int minCapacity) {<br />
        // overflow-conscious code<br />
        int oldCapacity = elementData.length;<br />
        //新容量为旧容量的1.5倍<br />
        int newCapacity = oldCapacity + (oldCapacity &gt;&gt; 1);<br />
        if (newCapacity - minCapacity &lt; 0)<br />
            newCapacity = minCapacity;<br />
        if (newCapacity - MAX_ARRAY_SIZE &gt; 0)<br />
            newCapacity = hugeCapacity(minCapacity);<br />
        // minCapacity is usually close to size, so this is a win:<br />
        //将元素组里面的内容复制到新的数组里面去<br />
        elementData = Arrays.copyOf(elementData, newCapacity);<br />
    }<br />
</code></pre>
<p>可以看到，调整容量的过程其实是扩容了数组的容量，并在最后调用了Arrays的copyOf方法 ，等于把元素组里面的内容复制到新的数组里面去，</p>
<pre class="prettyprint linenums"><code>public static &lt;T,U&gt; T[] copyOf(U[] original, int newLength, Class&lt;? extends T[]&gt; newType) {<br />
    @SuppressWarnings(&quot;unchecked&quot;)<br />
    T[] copy = ((Object)newType == (Object)Object[].class)<br />
        ? (T[]) new Object[newLength]<br />
        : (T[]) Array.newInstance(newType.getComponentType(), newLength);<br />
    System.arraycopy(original, 0, copy, 0,<br />
                     Math.min(original.length, newLength));<br />
    return copy;<br />
}<br />
</code></pre>
<p>用一张图来表示是这样的<br /><br />
<img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1478697/201811/1478697-20181113232445018-1427645229.png"></p>
<p>除了上面的add 方法外，ArrayList还提供了几个添加操作的方法，分别是</p>
<pre class="prettyprint linenums"><code>//在指定位置添加元素<br />
public void add(int index, E element) {<br />
	//判断index是否在size范围内<br />
    rangeCheckForAdd(index);

    ensureCapacityInternal(size + 1);  // Increments modCount!!<br />
    //整体复制，并后移一位<br />
    System.arraycopy(elementData, index, elementData, index + 1,<br />
                     size - index);<br />
    elementData[index] = element;<br />
    size++;<br />
}<br />
//添加整个集合<br />
public boolean addAll(Collection&lt;? extends E&gt; c) {<br />
    Object[] a = c.toArray();<br />
    int numNew = a.length;<br />
    ensureCapacityInternal(size + numNew);  // Increments modCount<br />
    System.arraycopy(a, 0, elementData, size, numNew);<br />
    size += numNew;<br />
    return numNew != 0;<br />
 }

 //在指定位置，添加一个集合<br />
 public boolean addAll(int index, Collection&lt;? extends E&gt; c) {<br />
        rangeCheckForAdd(index);<br />
	    //把该集合转为对象数组<br />
        Object[] a = c.toArray();<br />
        int numNew = a.length;<br />
        ensureCapacityInternal(size + numNew);  // Increments modCount

        int numMoved = size - index;<br />
        if (numMoved &gt; 0)<br />
            System.arraycopy(elementData, index, elementData, index + numNew,<br />
                             numMoved);

        System.arraycopy(a, 0, elementData, index, numNew);<br />
        size += numNew;<br />
        return numNew != 0;<br />
    }<br />
</code></pre>
<p>这三个方法虽然也是插入的操作，但其实最后都是调用 System 的 arraycopy 方法做一个整体的复制，这是一个native的方法，功能就是把数组做一个整体的复制，并向后移了一位。如果要复制的元素很多，那么就比较耗费性能，这是比较不好的一点。</p>
<p>所以，一般情况下，ArrayList适合顺序添加的情景。</p>
<h2>查询元素</h2>
<pre class="prettyprint linenums"><code>E elementData(int index) {<br />
        return (E) elementData[index];<br />
}

public E get(int index) {<br />
    rangeCheck(index);

    return elementData(index);<br />
}<br />
</code></pre>
<p>查询的代码比较简单，都是直接返回数组对应位置的元素，充分利用了数组根据索引查询元素的优势吗，因此效率较高。</p>
<p>扩展：说到查询，来提一个知识点，那就是遍历元素的效率问题，前面说了，ArrayList 实现了RandomAccess 接口，所以 遍历ArrayList 的元素 get() 获取元素在效率上是优于迭代器的，至于原因，在 <a href="https://www.cnblogs.com/yeya/p/9950723.html" rel="external nofollow noreferrer">《Java集合类：&quot;随机访问&quot; 的RandomAccess接口》</a>有介绍，这里不进行叙述了。</p>
<h2>修改元素</h2>
<pre class="prettyprint linenums"><code>public E set(int index, E element) {<br />
    rangeCheck(index);

    E oldValue = elementData(index);<br />
    elementData[index] = element;<br />
    return oldValue;<br />
}<br />
</code></pre>
<p>也是根据索引操作数组 ，不多说。</p>
<h2>删除元素</h2>
<p>ArrayList删除元素的方法比较多，但说起来无非是三类，</p>
<p>1、按照下标删除元素</p>
<p>2、按照元素删除，这会删除ArrayList中与指定要删除的元素匹配的第一个元素</p>
<p>3、清除数组元素</p>
<p>前面两种虽然功能不同，但代码的最终调用是差不多的，都是引用类似这段代码来解决问题：</p>
<pre class="prettyprint linenums"><code>int numMoved = size - index - 1;<br />
if (numMoved &gt; 0)<br />
    System.arraycopy(elementData, index+1, elementData, index,<br />
                     numMoved);<br />
elementData[--size] = null; // clear to let GC do its work<br />
</code></pre>
<p>这段代码的逻辑大概就是把指定元素后面的所有元素整体复制并向前移动一个位置，然后最后一个元素置为null，跟插入中的部分方法逻辑很像，都是调用 System.arraycopy 来做数组操作，所以说，删除元素的效率其实也是不高的。</p>
<p>而第三类删除的方法其实是调用 <strong>clear</strong> ，</p>
<pre class="prettyprint linenums"><code>public void clear() {<br />
    modCount++;

    // clear to let GC do its work<br />
    for (int i = 0; i &lt; size; i++)<br />
        elementData[i] = null;

    size = 0;<br />
}<br />
</code></pre>
<p>把数组的每个元素都置为null，并把size置为0，就这么简单。</p>
<h1>为什么用 &quot;transient&quot; 修饰数组变量</h1>
<p>最后一个问题，之前说了ArrayList 可以被序列化，但其数组变量却是用<strong>transient</strong> 修饰，这是为什么呢？按照 <a href="https://www.cnblogs.com/xrq730/p/4989451.html" rel="external nofollow noreferrer">五月的仓颉</a> 大神这篇文章的解释就是：</p>
<p>序列化ArrayList的时候，ArrayList里面的elementData未必是满的，比方说elementData有10的大小，但是我只用了其中的3个，那么是否有必要序列化整个elementData呢？显然没有这个必要，因此ArrayList中重写了writeObject方法：</p>
<pre class="prettyprint linenums"><code>private void writeObject(java.io.ObjectOutputStream s)<br />
    throws java.io.IOException{<br />
    // Write out element count, and any hidden stuff<br />
    int expectedModCount = modCount;<br />
    s.defaultWriteObject();

    // Write out size as capacity for behavioural compatibility with clone()<br />
    s.writeInt(size);

    // Write out all elements in the proper order.<br />
    for (int i=0; i&lt;size; i++) {<br />
        s.writeObject(elementData[i]);<br />
    }

    if (modCount != expectedModCount) {<br />
        throw new ConcurrentModificationException();<br />
    }<br />
}<br />
</code></pre>
<p>每次序列化的时候调用这个方法，先调用defaultWriteObject()方法序列化ArrayList中的非transient元素，elementData不去序列化它，然后遍历elementData，只序列化那些有的元素，这样：</p>
<p>1、加快了序列化的速度</p>
<p>2、减小了序列化之后的文件大小</p>
<p>不得不说，设计者还是很用心良苦的。</p>
<h1>总结</h1>
<p>ArrayList 的源码分析就到这里了，因为其底层只有数组，所以源码的逻辑还是比较简单，比起HashMap这样的学习起来要轻松多了  (HashMap源码学习过程回想起来真是痛苦啊												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8kmzxr9.html">react native  TextInput</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qne1zjq.html">orcale  动态执行语句</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kg0n39.html">Entity Framework 教程</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwmmrz8.html">Codeforces Round &num;162 &lpar;Div&period; 2&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96wvyvq.html">Maven学习8-使用Maven构建多模块项目</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmnzz19.html">安卓高手之路之PackageManagerservice</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2w2omlq.html">android多分辨率多屏幕密度下UI适配方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vl7z38.html">客户端动态调用cxf websevice 异常</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kppx479.html">Html&period;Partial和Html&period; RenderPartial</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp5p0j9.html">C&plus;&plus;&sol;C语言程序代码</a>
		</li>
						<li><a href="https://www.batexi.com/a/950zmw68.html">Linux安装解压缩版jdk</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mexlg0q.html">Vue深度学习（6）- 组件</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkpro08.html">认证与Shiro安全框架</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2j7kl38.html">Gradle入门与使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25wgwvq.html">如何使用python在保留原excel格式的前提下插入&sol;修改数据</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2z2no9.html">3D游戏的角色移动和旋转</a>
		</li>
						<li><a href="https://www.batexi.com/a/qll6egxq.html">深入理解java虚拟机读后总结（个人总结记录）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyvwy62q.html">洛谷P1208</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7ex22e9.html">大数据入门第十七天&mdash;&mdash;storm上游数据源 之kafka详解（二）常用命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/963odj39.html">&lbrack;转载&rsqb;Juicer &ndash; 一个Javascript模板引擎的实现和优化</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q7zkr4e9.html">为不具有change事件的html标签设置监听事件</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zo0djxq.html">http&colon;&sol;&sol;www&period;layui&period;com&sol;doc&sol;modules&sol;laydate&period;html实时通信&bsol;日期、&equals;&equals;插件</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4zlx1n9.html">【二代示波器教程】第12章 示波器设计&mdash;DAC信号发生器的实现</a>
			</li>
						<li><a href="https://www.batexi.com/a/9geongz8.html">LeetCode题解39&period;Combination Sum</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rgvjo48.html">&lbrack;Swift&rsqb;LeetCode112&period; 路径总和 &vert; Path Sum</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlj6zy09.html">&lbrack;Swift&rsqb;LeetCode123&period; 买卖股票的最佳时机 III &vert; Best Time to Buy and Sell Stock III</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy1md52q.html">spring-cloud-sleuth&plus;zipkin源码探究</a>
			</li>
						<li><a href="https://www.batexi.com/a/96pxoej8.html">dpkg&colon; 处理软件包 xxx &lpar;--configure&rpar;时出错 解决办法</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ojzk7xq.html">JSONP和CORS两种跨域方式的优缺点及使用方法原理介绍</a>
			</li>
						<li><a href="https://www.batexi.com/a/8eyny0j9.html">Spring Boot 面试题</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
